# coding: utf-8

"""
    OGC API - Processes

    Example API Definition for OGC API - Processes  # noqa: E501

    The version of the OpenAPI document: 0.1
    Contact: info@ogc.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
#from openapi_client.models.description_type_additional_parameters import DescriptionTypeAdditionalParameters
from openapi_client.models.input_description_all_of_max_occurs import InputDescriptionAllOfMaxOccurs
from openapi_client.models.metadata import Metadata
from openapi_client.models.copy2_model_schema import ModelSchema
from openapi_client.models.copy2_additional_parameter import AdditionalParameter2

class InputDescription(BaseModel):
    """
    InputDescription
    """
    title: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    keywords: Optional[conlist(StrictStr)] = None
    metadata: Optional[conlist(Metadata)] = None
    additional_parameters: Optional[conlist(AdditionalParameter2)] = Field(None, alias="additionalParameters")
    min_occurs: Optional[StrictInt] = Field(1, alias="minOccurs")
    max_occurs: Optional[InputDescriptionAllOfMaxOccurs] = Field(None, alias="maxOccurs")
    var_schema: ModelSchema = Field(..., alias="schema")
    __properties = ["title", "description", "keywords", "metadata", "additionalParameters", "minOccurs", "maxOccurs", "schema"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> InputDescription:
        """Create an instance of InputDescription from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in metadata (list)
        _items = []
        if self.metadata:
            for _item in self.metadata:
                if _item:
                    _items.append(_item.to_dict())
            _dict['metadata'] = _items
        # override the default output from pydantic by calling `to_dict()` of additional_parameters
        #if self.additional_parameters:
        #    _dict['additionalParameters'] = self.additional_parameters.to_dict()
        # override the default output from pydantic by calling `to_dict()` of additional_parameters
        _items =[]
        if self.additional_parameters:
            for _item in self.additional_parameters:
                if _item:
                    _items.append(_item.to_dict())
            _dict['additionalParameters'] = _items
        # override the default output from pydantic by calling `to_dict()` of max_occurs
        if self.max_occurs:
            _dict['maxOccurs'] = self.max_occurs.to_dict()
        # override the default output from pydantic by calling `to_dict()` of var_schema
        if self.var_schema:
            _dict['schema'] = self.var_schema.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> InputDescription:
        """Create an instance of InputDescription from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return InputDescription.parse_obj(obj)

        _obj = InputDescription.parse_obj({
            "title": obj.get("title"),
            "description": obj.get("description"),
            "keywords": obj.get("keywords"),
            "metadata": [Metadata.from_dict(_item) for _item in obj.get("metadata")] if obj.get("metadata") is not None else None,
            "additional_parameters": [AdditionalParameter2.from_dict(_item) for _item in obj.get("additionalParameters")] if obj.get("additionalParameters") is not None else None,
            "min_occurs": obj.get("minOccurs"),
            "max_occurs": InputDescriptionAllOfMaxOccurs.from_dict(obj.get("maxOccurs")) if obj.get("maxOccurs") is not None else None,
            "var_schema": ModelSchema.from_dict(obj.get("schema")) if obj.get("schema") is not None else None
        })
        return _obj

