# coding: utf-8

"""
    OGC API - Processes

    Example API Definition for OGC API - Processes  # noqa: E501

    The version of the OpenAPI document: 0.1
    Contact: info@ogc.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, conlist
from openapi_client.models.extent_spatial_grid_inner_coordinates_inner import ExtentSpatialGridInnerCoordinatesInner
from openapi_client.models.extent_spatial_grid_inner_resolution import ExtentSpatialGridInnerResolution

class ExtentSpatialGridInner(BaseModel):
    """
    ExtentSpatialGridInner
    """
    coordinates: Optional[conlist(ExtentSpatialGridInnerCoordinatesInner, min_items=1)] = Field(None, description="List of coordinates along the dimension for which data organized as an irregular grid in the collection is available (e.g., 2, 10, 80, 100).")
    cells_count: Optional[StrictInt] = Field(None, alias="cellsCount", description="Number of samples available along the dimension for data organized as a regular grid. For values representing the whole area of contiguous cells spanning _resolution_ units along the dimension, this will be (_upperBound_ - _lowerBound_) / _resolution_. For values representing infinitely small point cells spaced by _resolution_ units along the dimension, this will be (_upperBound_ - _lowerBound_) / _resolution_ + 1.")
    resolution: Optional[ExtentSpatialGridInnerResolution] = None
    __properties = ["coordinates", "cellsCount", "resolution"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ExtentSpatialGridInner:
        """Create an instance of ExtentSpatialGridInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in coordinates (list)
        _items = []
        if self.coordinates:
            for _item in self.coordinates:
                if _item:
                    _items.append(_item.to_dict())
            _dict['coordinates'] = _items
        # override the default output from pydantic by calling `to_dict()` of resolution
        if self.resolution:
            _dict['resolution'] = self.resolution.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ExtentSpatialGridInner:
        """Create an instance of ExtentSpatialGridInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ExtentSpatialGridInner.parse_obj(obj)

        _obj = ExtentSpatialGridInner.parse_obj({
            "coordinates": [ExtentSpatialGridInnerCoordinatesInner.from_dict(_item) for _item in obj.get("coordinates")] if obj.get("coordinates") is not None else None,
            "cells_count": obj.get("cellsCount"),
            "resolution": ExtentSpatialGridInnerResolution.from_dict(obj.get("resolution")) if obj.get("resolution") is not None else None
        })
        return _obj

