# coding: utf-8

"""
    OGC API - Processes

    Example API Definition for OGC API - Processes  # noqa: E501

    The version of the OpenAPI document: 0.1
    Contact: info@ogc.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, conlist, validator
from openapi_client.models.link import Link
from openapi_client.models.link_image import LinkImage
from openapi_client.models.ogcapppkg_execution_unit_one_of import OgcapppkgExecutionUnitOneOf
from openapi_client.models.ogcapppkg_execution_unit_one_of1_inner import OgcapppkgExecutionUnitOneOf1Inner
from openapi_client.models.qualified_input_value import QualifiedInputValue
from typing import Any, List
from pydantic import StrictStr, Field

OGCAPPPKGEXECUTIONUNIT_ONE_OF_SCHEMAS = ["Link", "List[OgcapppkgExecutionUnitOneOf1Inner]", "OgcapppkgExecutionUnitOneOf", "QualifiedInputValue"]

class OgcapppkgExecutionUnit(BaseModel):
    """
    OgcapppkgExecutionUnit
    """
    # data type: OgcapppkgExecutionUnitOneOf
    oneof_schema_1_validator: Optional[OgcapppkgExecutionUnitOneOf] = None
    # data type: Link
    oneof_schema_2_validator: Optional[Link] = None
    # data type: QualifiedInputValue
    oneof_schema_3_validator: Optional[QualifiedInputValue] = None
    # data type: List[OgcapppkgExecutionUnitOneOf1Inner]
    oneof_schema_4_validator: Optional[conlist(OgcapppkgExecutionUnitOneOf1Inner)] = None
    # data type: LinkImage
    oneof_schema_5_validator: Optional[LinkImage] = None
    actual_instance: Any
    one_of_schemas: List[str] = Field(OGCAPPPKGEXECUTIONUNIT_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs):
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = OgcapppkgExecutionUnit.construct()
        error_messages = []
        match = 0
        # validate data type: OgcapppkgExecutionUnitOneOf
        if not isinstance(v, OgcapppkgExecutionUnitOneOf):
            error_messages.append(f"Error! Input type `{type(v)}` is not `OgcapppkgExecutionUnitOneOf`")
        else:
            match += 1
        # validate data type: Link
        if not isinstance(v, Link):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Link`")
        else:
            match += 1
        # validate data type: QualifiedInputValue
        if not isinstance(v, QualifiedInputValue):
            error_messages.append(f"Error! Input type `{type(v)}` is not `QualifiedInputValue`")
        else:
            match += 1
        # validate data type: LinkImage
        if not isinstance(v, LinkImage):
            error_messages.append(f"Error! Input type `{type(v)}` is not `LinkImage`")
        else:
            match += 1
        # validate data type: List[OgcapppkgExecutionUnitOneOf1Inner]
        try:
            instance.oneof_schema_4_validator = v
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in OgcapppkgExecutionUnit with oneOf schemas: Link, List[OgcapppkgExecutionUnitOneOf1Inner], OgcapppkgExecutionUnitOneOf, QualifiedInputValue. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in OgcapppkgExecutionUnit with oneOf schemas: Link, List[OgcapppkgExecutionUnitOneOf1Inner], OgcapppkgExecutionUnitOneOf, QualifiedInputValue. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> OgcapppkgExecutionUnit:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> OgcapppkgExecutionUnit:
        """Returns the object represented by the json string"""
        instance = OgcapppkgExecutionUnit.construct()
        error_messages = []
        match = 0

        # deserialize data into OgcapppkgExecutionUnitOneOf
        try:
            instance.actual_instance = OgcapppkgExecutionUnitOneOf.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into Link
        try:
            instance.actual_instance = Link.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into QualifiedInputValue
        try:
            instance.actual_instance = QualifiedInputValue.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into List[OgcapppkgExecutionUnitOneOf1Inner]
        try:
            # validation
            instance.oneof_schema_4_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.oneof_schema_4_validator
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into OgcapppkgExecutionUnit with oneOf schemas: Link, List[OgcapppkgExecutionUnitOneOf1Inner], OgcapppkgExecutionUnitOneOf, QualifiedInputValue. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into OgcapppkgExecutionUnit with oneOf schemas: Link, List[OgcapppkgExecutionUnitOneOf1Inner], OgcapppkgExecutionUnitOneOf, QualifiedInputValue. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

